﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ApiDePaul.DTO;
using Model;

namespace ApiDePaul
{
    public static class ChampionMapping
    {
        public static ChampionDto ChampToDto(this Champion c)
        {
            return new ChampionDto()
            {
                Name = c.Name,
                Bio = c.Bio,
                Icon = c.Icon,
                Characteristics = c.Characteristics.ToDictionary(x => x.Key, x => x.Value)
            };
        }
        public static Champion DtoToChamp(this ChampionDto c)
        {
            Champion champ = new Champion(c.Name);
            //champ.Class = (ChampionClass)Enum.Parse(typeof(ChampionClass),c.Class);
            champ.Icon = c.Icon;
            //champ.Image = c.Image;
            champ.Bio = c.Bio;

            return champ;
        }
    }
}